void

#include "Lib/ff.h"
 printAlarmText()
{
    if (currentTime.second % 2 == 0)
    {
        lcd_printTime(currentTime.hour, currentTime.minute, ramSettings.timeMode);
    }
    else
    {
        lcd_setPos(0, 1);
        //                           1234567890123456
        fprintf_P(&lcd_stdout, PSTR("  Wake   Up!!!  "));
        lcd_setPos(0, 2);
        if (currentTime.dayOfWeek == 0)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("  It's Monday!  "));
        }
        else if (currentTime.dayOfWeek == 1)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR(" It's  Tuesday! "));
        }
        else if (currentTime.dayOfWeek == 2)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("It's  Wednesday!"));
        }
        else if (currentTime.dayOfWeek == 3)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR(" It's Thursday! "));
        }
        else if (currentTime.dayOfWeek == 4)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("  It's Friday!  "));
        }
        else if (currentTime.dayOfWeek == 5)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR(" It's Saturday! "));
        }
        else if (currentTime.dayOfWeek == 6)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("  It's Sunday!  "));
        }
    }
}

void alarm()
{
    lcd_printTime(currentTime.hour, currentTime.minute, ramSettings.timeMode);

    bool_t found = bool_false;
    FATFS alarmFatFs;
    FIL alarmFile;
    DIR alarmDir;
    FILINFO alarmFileInfo;

    mp3_powerUp();
    disk_initialize(0);
    err = f_mount(0, &alarmFatFs); // force remount
    err = f_opendir(&alarmDir, "/alarms");
    
    bool_t looped = bool_false;

    wdt_reset();

    uint8_t failedCnt = 0;

    while (1)
    {
        err = f_readdir(&alarmDir, &alarmFileInfo);
        if (err == FR_OK && alarmFileInfo.fname[0] != 0 && (alarmFileInfo.fattrib & AM_DIR) == 0)
        { // if exists and is not a directory


            // match name to day, the name matching is forgiving, as long as the filename starts sort of right
            if ((currentTime.dayOfWeek == 0 && memcmp("mon", alarmFileInfo.fname, 3) == 0) ||
                (currentTime.dayOfWeek == 1 && memcmp("tue", alarmFileInfo.fname, 3) == 0) ||
                (currentTime.dayOfWeek == 2 && memcmp("wed", alarmFileInfo.fname, 3) == 0) ||
                (currentTime.dayOfWeek == 3 && memcmp("thu", alarmFileInfo.fname, 3) == 0) ||
                (currentTime.dayOfWeek == 4 && memcmp("fri", alarmFileInfo.fname, 3) == 0) ||
                (currentTime.dayOfWeek == 5 && memcmp("sat", alarmFileInfo.fname, 3) == 0) ||
                (currentTime.dayOfWeek == 6 && memcmp("sun", alarmFileInfo.fname, 3) == 0) ||
                (currentTime.dayOfWeek == 0 && memcmp("MON", alarmFileInfo.fname, 3) == 0) ||
                (currentTime.dayOfWeek == 1 && memcmp("TUE", alarmFileInfo.fname, 3) == 0) ||
                (currentTime.dayOfWeek == 2 && memcmp("WED", alarmFileInfo.fname, 3) == 0) ||
                (currentTime.dayOfWeek == 3 && memcmp("THU", alarmFileInfo.fname, 3) == 0) ||
                (currentTime.dayOfWeek == 4 && memcmp("FRI", alarmFileInfo.fname, 3) == 0) ||
                (currentTime.dayOfWeek == 5 && memcmp("SAT", alarmFileInfo.fname, 3) == 0) ||
                (currentTime.dayOfWeek == 6 && memcmp("SUN", alarmFileInfo.fname, 3) == 0)
            ) // quick note, apparently FatFs likes everything uppercase
            {
                char path[1 + 6 + 1 + 8 + 1 + 3 + 2] =
                { '/', 'a', 'l', 'a', 'r', 'm', 's', '/',
                alarmFileInfo.fname[0],
                alarmFileInfo.fname[1],
                alarmFileInfo.fname[2],
                alarmFileInfo.fname[3],
                alarmFileInfo.fname[4],
                alarmFileInfo.fname[5],
                alarmFileInfo.fname[6],
                alarmFileInfo.fname[7],
                alarmFileInfo.fname[8],
                alarmFileInfo.fname[9],
                alarmFileInfo.fname[10],
                alarmFileInfo.fname[11],
                alarmFileInfo.fname[12],
                0, };

                err = f_open(&alarmFile, path, FA_READ);
                if (err == FR_OK)
                {
                    found = bool_true;
                    break;
                }
            }
        }
        else if (err == FR_OK && alarmFileInfo.fname[0] == 0)
        {
            err = f_opendir(&alarmDir, "/alarms");
            if (err != FR_OK) break;
            if (looped != bool_false) break;
            looped = bool_true;
        }
        else if (err != FR_OK && failedCnt < 3)
        {
            disk_initialize(0);
            err = f_mount(0, &alarmFatFs); // force remount
            err = f_opendir(&alarmDir, "/alarms");

            failedCnt++;
        }
        else if (err != FR_OK)
        {
             break;
        }
    }
    
    if (found == bool_false) // card error or missing file, just play sine test;
    {
        mp3_startSineTest();
        while (irctrl_getCmd() == ircmd_none)
        {
            mp3_setVolume(currentTime.second % 2 == 0 ? 255 : 254);
            printAlarmText();
            wdt_reset();
        }
        mp3_stopSineTest();
    }
    else
    {
        // play until hit any button
        while (irctrl_getCmd() == ircmd_none)
        {
            bool_t messWithVol = alarmFile.fptr == 0;
            if (mp3_playFile(&alarmFile) == playstatus_endOfFile)
            { // rewind if reached end
                f_lseek(&alarmFile, 0);
            }

            if (messWithVol != bool_false)
            {
                mp3_setVolume(255);
            }
            else
            {
                mp3_setVolume(254);
            }

            printAlarmText();
            wdt_reset();
        }
    }
    
    irctrl_clearCmd();
}