#ifndef lcd_h_
#define lcd_h_

#include <avr/io.h> // for AVR hardware

#include "pins.h"

// macros to control LCD's backlight
#define lcd_backlight(x) LCD_PORT = x ? (LCD_PORT | _BV(LCD_PIN_LED)) : (PORTF & ~_BV(LCD_PIN_LED)
#define lcd_backlightOn() LCD_PORT |= _BV(LCD_PIN_LED)
#define lcd_backlightOff() LCD_PORT &= ~_BV(LCD_PIN_LED)

// function prototypes

// initialize pin states
inline void lcd_initPins();

// send a byte to the LCD, RS pin must be setup before calling this function
inline void lcd_sendByte(uint8_t x);

// display a character on the LCD
void lcd_sendChar(char c);

// send a command to the LCD
void lcd_sendCmd(uint8_t data);

// sets the position of the cursor, x is 0 indexed, line is not
void lcd_setPos(uint8_t x, uint8_t line);

// initialize the LCD
void lcd_init();

// print big number clock
void lcd_printTime(uint8_t hour, uint8_t minute, uint8_t ampm);


#endif