void showMenu()
{    
    lcd_setPos(0, 1);
    
    if (ramSettings.submenu == submenu_playMode)
    {
        //                           1234567890123456
        fprintf_P(&lcd_stdout, PSTR("   Play Mode:   "));
        lcd_setPos(0, 2);
        if (ramSettings.playMode == playmode_normal)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("     Normal     "));
        }
        else if (ramSettings.playMode == playmode_loop)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("      Loop      "));
        }
        else if (ramSettings.playMode == playmode_shuffle)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("     Shuffle    "));
        }
        else if (ramSettings.playMode == playmode_once)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("   Only  Once   "));
        }
        else
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("      Error     "));
        }
    }
    else if (ramSettings.submenu == submenu_timeMode)
    {
        //                           1234567890123456
        fprintf_P(&lcd_stdout, PSTR("Time Disp Mode: "));
        lcd_setPos(0, 2);
        if (ramSettings.timeMode == timemode_twelve)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("   AM/PM Mode   "));
        }
        else
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("  24 Hour Mode  "));
        }
    }
    else if (ramSettings.submenu == submenu_usbMode)
    {
        //                           1234567890123456
        fprintf_P(&lcd_stdout, PSTR("   USB  Mode:   "));
        lcd_setPos(0, 2);
        if (isUsbEnabled == bool_false)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("      OFF       "));
        }
        else
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("       ON       "));
        }
    }
    else if (ramSettings.submenu == submenu_currentTimeHour)
    {
        //                           1234567890123456
        fprintf_P(&lcd_stdout, PSTR(" Current  Time: "));
        lcd_setPos(0, 2);
        fprintf_P(&lcd_stdout, PSTR("    >"));
        printTwoNum_P(&lcd_stdout, currentTime.hour);
        fprintf_P(&lcd_stdout, PSTR("< : "));
        printTwoNum_P(&lcd_stdout, currentTime.minute);
        fprintf_P(&lcd_stdout, PSTR("    "));
    }
    else if (ramSettings.submenu == submenu_currentTimeMinute)
    {
        //                           1234567890123456
        fprintf_P(&lcd_stdout, PSTR(" Current  Time: "));
        lcd_setPos(0, 2);
        fprintf_P(&lcd_stdout, PSTR("    "));
        printTwoNum_P(&lcd_stdout, currentTime.hour);
        fprintf_P(&lcd_stdout, PSTR(" : >"));
        printTwoNum_P(&lcd_stdout, currentTime.minute);
        fprintf_P(&lcd_stdout, PSTR("<    "));
    }
    else if (ramSettings.submenu == submenu_currentDayOfWeek)
    {
        //                           1234567890123456
        fprintf_P(&lcd_stdout, PSTR("Cur Day of Week:"));
        lcd_setPos(0, 2);
        if (currentTime.dayOfWeek == 0)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("     Monday     "));
        }
        else if (currentTime.dayOfWeek == 1)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("     Tuesday    "));
        }
        else if (currentTime.dayOfWeek == 2)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("    Wednesday   "));
        }
        else if (currentTime.dayOfWeek == 3)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("    Thursday    "));
        }
        else if (currentTime.dayOfWeek == 4)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("     Friday     "));
        }
        else if (currentTime.dayOfWeek == 5)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("    Saturday    "));
        }
        else if (currentTime.dayOfWeek == 6)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("     Sunday    "));
        }
        else
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("      Error     "));
        }
    }
    else if (ramSettings.submenu >= submenu_alarms && ramSettings.submenu < submenu_end)
    {
        uint8_t optIdx = (ramSettings.submenu - submenu_alarms) % 3; // 0 = on/off, 1 = hour, 2 = minute
        uint8_t dayIdx = (ramSettings.submenu - submenu_alarms - optIdx) / 3;
        
        if (dayIdx == 0)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR(" Monday  Alarm: "));
        }
        else if (dayIdx == 1)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR(" Tuesday Alarm: "));
        }
        else if (dayIdx == 2)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("Wednesday Alarm:"));
        }
        else if (dayIdx == 3)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("Thursday  Alarm:"));
        }
        else if (dayIdx == 4)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR(" Friday  Alarm: "));
        }
        else if (dayIdx == 5)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("Saturday  Alarm:"));
        }
        else if (dayIdx == 6)
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR(" Sunday  Alarm: "));
        }
        else
        {
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("      Error     "));
            lcd_setPos(0, 2);
            fprintf_P(&lcd_stdout, PSTR("      Error     "));
        }
        lcd_setPos(0, 2);
        
        if (dayIdx >= 0 && dayIdx <= 6)
        {
            // sanity check, keep within valid range
            eepromSettings.alarmHour[dayIdx] = (eepromSettings.alarmHour[dayIdx] < 1 || eepromSettings.alarmHour[dayIdx] >= 25) ? 0 : eepromSettings.alarmHour[dayIdx];
            eepromSettings.alarmMinute[dayIdx] = (eepromSettings.alarmMinute[dayIdx] < 0 || eepromSettings.alarmMinute[dayIdx] >= 60) ? 0 : eepromSettings.alarmMinute[dayIdx];
            
            if (optIdx == 0)
            {
                fprintf_P(&lcd_stdout, PSTR("  >%s< "), bit_is_set(eepromSettings.alarmMask, dayIdx) ? "On " : "Off");
                printTwoNum_P(&lcd_stdout, eepromSettings.alarmHour[dayIdx]);
                fprintf_P(&lcd_stdout, PSTR(":"));
                printTwoNum_P(&lcd_stdout, eepromSettings.alarmMinute[dayIdx]);
                fprintf_P(&lcd_stdout, PSTR("   "));
            }
            else if (optIdx == 1)
            {
                fprintf_P(&lcd_stdout, PSTR("  %s >"), bit_is_set(eepromSettings.alarmMask, dayIdx) ? "On " : "Off");
                printTwoNum_P(&lcd_stdout, eepromSettings.alarmHour[dayIdx]);
                fprintf_P(&lcd_stdout, PSTR("< :"));
                printTwoNum_P(&lcd_stdout, eepromSettings.alarmMinute[dayIdx]);
                fprintf_P(&lcd_stdout, PSTR("  "));
            }
            else if (optIdx == 2)
            {
                fprintf_P(&lcd_stdout, PSTR("  %s  "), bit_is_set(eepromSettings.alarmMask, dayIdx) ? "On " : "Off");
                printTwoNum_P(&lcd_stdout, eepromSettings.alarmHour[dayIdx]);
                fprintf_P(&lcd_stdout, PSTR(": >"));
                printTwoNum_P(&lcd_stdout, eepromSettings.alarmMinute[dayIdx]);
                fprintf_P(&lcd_stdout, PSTR("<  "));
            }
            else
            {
                fprintf_P(&lcd_stdout, PSTR("      Error     "));
            }
        }
    }
    else
    {
        //                           1234567890123456
        fprintf_P(&lcd_stdout, PSTR("      Error     "));
        lcd_setPos(0, 2);
        fprintf_P(&lcd_stdout, PSTR("      Error     "));
    }
}

tosave_t runMenu()
{
    tosave_t dirty = tosave_none; // the bits in this variable indicate what memory to save to
    
    // sanity check, keep within valid range
    ramSettings.submenu = (ramSettings.submenu < 0 || ramSettings.submenu >= submenu_end) ? 0 : ramSettings.submenu;
    
    if (irctrl_getCmd() == ircmd_right && irctrl_isHeldDown() == 0)
    {
        irctrl_clearCmd();
        
        ramSettings.submenu++;

        // skip over if not available
        #if !defined(__AVR_AT90USB1286__) || !defined(USE_USB)
        if (ramSettings.submenu == submenu_usbMode) ramSettings.submenu++;
        #endif

        if (ramSettings.submenu >= submenu_end)
        {
            ramSettings.submenu = 0;
        }
        
        dirty |= tosave_ram;
        
        oneShotTimer_go(5); // suppress time display
    }
    else if (irctrl_getCmd() == ircmd_left && irctrl_isHeldDown() == 0)
    {
        irctrl_clearCmd();
        
        ramSettings.submenu--;

        // skip over if not available
        #if !defined(__AVR_AT90USB1286__) || !defined(USE_USB)
        if (ramSettings.submenu == submenu_usbMode) ramSettings.submenu--;
        #endif

        if (ramSettings.submenu > submenu_end || ramSettings.submenu < 0)
        {
            ramSettings.submenu = submenu_end - 1;
        }
        
        dirty |= tosave_ram;
        
        oneShotTimer_go(5); // suppress time display
    }
    else if (irctrl_getCmd() == ircmd_menu && irctrl_isHeldDown() == 0)
    {
        irctrl_clearCmd();
        
        isInMenu = bool_false;
        
        oneShotTimer_go(0);
        
        return dirty;
    }

    if (ramSettings.submenu == submenu_playMode)
    {
        
        // sanity check, keep in valid range
        ramSettings.playMode = (ramSettings.playMode < 0 || ramSettings.playMode >= playmode_end) ? 0 : ramSettings.playMode;
        
        // set according to command
        if (irctrl_getCmd() == ircmd_up && irctrl_isHeldDown() == 0)
        {
            irctrl_clearCmd();
            
            ramSettings.playMode++;
            if (ramSettings.playMode >= playmode_end)
            {
                ramSettings.playMode = 0;
            }
            
            dirty |= tosave_ram;
        }
        else if (irctrl_getCmd() == ircmd_down && irctrl_isHeldDown() == 0)
        {
            irctrl_clearCmd();
            
            ramSettings.playMode--;
            if (ramSettings.playMode > playmode_end || ramSettings.playMode < 0)
            {
                ramSettings.playMode = playmode_end - 1;
            }
            
            dirty |= tosave_ram;
        }
    }
    else if (ramSettings.submenu == submenu_timeMode)
    {
        // set according to command
        if ((irctrl_getCmd() == ircmd_up || irctrl_getCmd() == ircmd_down) && irctrl_isHeldDown() == 0)
        {
            irctrl_clearCmd();
            
            if (ramSettings.timeMode == timemode_twelve)
            {
                ramSettings.timeMode = timemode_twentyFour;
            }
            else
            {
                ramSettings.timeMode = timemode_twelve;
            }
            
            dirty |= tosave_ram;
        }
    }
    else if (ramSettings.submenu == submenu_usbMode)
    {
        #if !defined(__AVR_AT90USB1286__) || !defined(USE_USB)
        ramSettings.submenu++;
        #else

        // toggle on change
        if ((irctrl_getCmd() == ircmd_up || irctrl_getCmd() == ircmd_down) && irctrl_isHeldDown() == 0)
        {
            irctrl_clearCmd();

            isUsbEnabled = isUsbEnabled == bool_false ? bool_true : bool_false;

            if (isUsbEnabled != bool_false)
            {
                USB_Enable();
            }
            else
            {
                USB_Disable();
            }
        }
        #endif
    }
    else if (ramSettings.submenu == submenu_currentTimeHour)
    {
        // sanity check, keep in valid range
        currentTime.hour = (currentTime.hour <= 0 || currentTime.hour >= 24) ? 24 : currentTime.hour;
        
        // set according to command
        if (irctrl_getCmd() == ircmd_up)
        {
            irctrl_clearCmd();
            
            currentTime.hour++;
            if (currentTime.hour >= 25)
            {
                currentTime.hour = 1;
            }
            
            dirty |= tosave_time;
        }
        else if (irctrl_getCmd() == ircmd_down)
        {
            irctrl_clearCmd();
            
            currentTime.hour--;
            if (currentTime.hour <= 0)
            {
                currentTime.hour = 24;
            }
            
            dirty |= tosave_time;
        }
    }
    else if (ramSettings.submenu == submenu_currentTimeMinute)
    {        
        // sanity check, keep in valid range
        currentTime.minute = (currentTime.minute < 0 || currentTime.minute >= 60) ? 0 : currentTime.minute;
        
        // set according to command
        if (irctrl_getCmd() == ircmd_up)
        {
            irctrl_clearCmd();
            
            currentTime.minute++;
            if (currentTime.minute >= 60)
            {
                currentTime.minute = 0;
            }
            
            dirty |= tosave_time;
        }
        else if (irctrl_getCmd() == ircmd_down)
        {
            irctrl_clearCmd();
            
            currentTime.minute--;
            if (currentTime.minute < 0 || currentTime.minute >= 60)
            {
                currentTime.minute = 59;
            }
            
            dirty |= tosave_time;
        }
    }
    else if (ramSettings.submenu == submenu_currentDayOfWeek)
    {        
        // sanity check, keep in valid range
        currentTime.dayOfWeek = (currentTime.dayOfWeek < 0 || currentTime.dayOfWeek > 6) ? 0 : currentTime.dayOfWeek;
        
        // set according to command
        if (irctrl_getCmd() == ircmd_up)
        {
            irctrl_clearCmd();
            
            currentTime.dayOfWeek++;
            if (currentTime.dayOfWeek > 6)
            {
                currentTime.dayOfWeek = 0;
            }
            
            dirty |= tosave_time;
        }
        else if (irctrl_getCmd() == ircmd_down)
        {
            irctrl_clearCmd();
            
            currentTime.dayOfWeek--;
            if (currentTime.dayOfWeek < 0 || currentTime.dayOfWeek > 6)
            {
                currentTime.dayOfWeek = 6;
            }
            
            dirty |= tosave_time;
        }
    }
    else if (ramSettings.submenu >= submenu_alarms && ramSettings.submenu < submenu_end)
    {
        uint8_t optIdx = (ramSettings.submenu - submenu_alarms) % 3; // 0 = on/off, 1 = hour, 2 = minute
        uint8_t dayIdx = (ramSettings.submenu - submenu_alarms - optIdx) / 3;
        
        if (dayIdx >= 0 && dayIdx <= 6)
        {
            // sanity check, keep within valid range
            eepromSettings.alarmHour[dayIdx] = (eepromSettings.alarmHour[dayIdx] < 1 || eepromSettings.alarmHour[dayIdx] >= 25) ? 0 : eepromSettings.alarmHour[dayIdx];
            eepromSettings.alarmMinute[dayIdx] = (eepromSettings.alarmMinute[dayIdx] < 0 || eepromSettings.alarmMinute[dayIdx] >= 60) ? 0 : eepromSettings.alarmMinute[dayIdx];
            
            if (optIdx == 0)
            {
                // toggle according to command
                if ((irctrl_getCmd() == ircmd_up || irctrl_getCmd() == ircmd_down) && irctrl_isHeldDown() == 0)
                {
                    irctrl_clearCmd();
                    
                    eepromSettings.alarmMask ^= _BV(dayIdx);
                    
                    dirty |= tosave_eeprom;
                }
            }
            else if (optIdx == 1)
            {
                // set according to command
                if (irctrl_getCmd() == ircmd_up)
                {
                    irctrl_clearCmd();
                    
                    eepromSettings.alarmHour[dayIdx]++;
                    if (eepromSettings.alarmHour[dayIdx] >= 25)
                    {
                        eepromSettings.alarmHour[dayIdx] = 1;
                    }
                
                    dirty |= tosave_eeprom;
                }
                else if (irctrl_getCmd() == ircmd_down)
                {
                    irctrl_clearCmd();
                    
                    eepromSettings.alarmHour[dayIdx]--;
                    if (eepromSettings.alarmHour[dayIdx] <= 0)
                    {
                        eepromSettings.alarmHour[dayIdx] = 24;
                    }
                    
                    dirty |= tosave_eeprom;
                }
            }
            else if (optIdx == 2)
            {
                // set according to command
                if (irctrl_getCmd() == ircmd_up)
                {
                    irctrl_clearCmd();
                    
                    eepromSettings.alarmMinute[dayIdx]++;
                    if (eepromSettings.alarmMinute[dayIdx] >= 60)
                    {
                        eepromSettings.alarmMinute[dayIdx] = 0;
                    }
                
                    dirty |= tosave_eeprom;
                }
                else if (irctrl_getCmd() == ircmd_down)
                {
                    irctrl_clearCmd();
                    
                    eepromSettings.alarmMinute[dayIdx]--;
                    if (eepromSettings.alarmMinute[dayIdx] < 0 || eepromSettings.alarmMinute[dayIdx] >= 60)
                    {
                        eepromSettings.alarmMinute[dayIdx] = 59;
                    }
                    
                    dirty |= tosave_eeprom;
                }
            }
        }
    }
    
    if (dirty != 0)
    {
        oneShotTimer_go(5); // suppress time display
    }
    
    return dirty;
}