#ifndef PINS_H
#define	PINS_H

#include <avr/io.h>

#ifdef	__cplusplus
extern "C" {
#endif

#if defined(__AVR_AT90USB1286__)
#define SPI_PORTDIR DDRB
#define SPI_PORTOUTPUT PORTB
#define SPI_PORTINPUT PINB
#define SPI_PIN_MOSI 2
#define SPI_PIN_MISO 3
#define SPI_PIN_SCK 1
#define SPI_PIN_SS 0

#define SDCARD_PORTDIR DDRB
#define SDCARD_PORTOUTPUT PORTB
#define SDCARD_PORTINPUT PINB
#define SDCARD_PIN_CS 0

#define MP3_PORTDIR DDRC
#define MP3_PORTOUTPUT PORTC
#define MP3_PORTINPUT PINC
#define MP3_PIN_CS 4
#define MP3_PIN_DCS 5
#define MP3_PIN_RST 7
#define MP3_PIN_DREQ 6

#define LCD_PORT PORTF
#define LCD_DDR DDRF
#define LCD_PIN_E 5
#define LCD_PIN_RS 4
#define LCD_PIN_LED 6

#define TWI_PORTDIR DDRD
#define TWI_PORTOUTPUT PORTD
#define TWI_PORTINPUT PIND
#define TWI_PIN_SDA 1
#define TWI_PIN_SCL 0

#define IRCTRL_PORTDIR DDRD
#define IRCTRL_PORTOUTPUT PORTD
#define IRCTRL_PORTINPUT PIND
#define IRCTRL_PIN 4
    
#elif defined(__AVR_ATmega644P__) || defined(__AVR_ATmega644__)
#define SPI_PORTDIR DDRB
#define SPI_PORTOUTPUT PORTB
#define SPI_PORTINPUT PINB
#define SPI_PIN_MOSI 5
#define SPI_PIN_MISO 6
#define SPI_PIN_SCK 7
#define SPI_PIN_SS 4

#define SDCARD_PORTDIR DDRB
#define SDCARD_PORTOUTPUT PORTB
#define SDCARD_PORTINPUT PINB
#define SDCARD_PIN_CS 4

#define MP3_PORTDIR DDRB
#define MP3_PORTOUTPUT PORTB
#define MP3_PORTINPUT PINB
#define MP3_PIN_CS 3
#define MP3_PIN_DCS 2
#define MP3_PIN_RST 1
#define MP3_PIN_DREQ 0

#define LCD_PORT PORTA
#define LCD_DDR DDRA
#define LCD_PIN_E 5
#define LCD_PIN_RS 4
#define LCD_PIN_LED 6

#define TWI_PORTDIR DDRC
#define TWI_PORTOUTPUT PORTC
#define TWI_PORTINPUT PINC
#define TWI_PIN_SDA 1
#define TWI_PIN_SCL 0

#define IRCTRL_PORTDIR DDRD
#define IRCTRL_PORTOUTPUT PORTD
#define IRCTRL_PORTINPUT PIND
#define IRCTRL_PIN 6
#endif



#ifdef	__cplusplus
}
#endif

#endif	/* PINS_H */

