#ifndef rtc_h_
#define rtc_h_

#define bcd_encode(x) ((((x)/10)<<4)+((x)%10))
#define bcd_decode(x) (((x)&0x0F)+((((x)&0xF0)>>4)*10))

#include "pins.h"

#define DS1307_ADDR 0b01101000
#define RTC_USERRAMSTART 0x08

void rtc_getTimeBurst(uint8_t* year, uint8_t* month, uint8_t* day, uint8_t* dayOfWeek, uint8_t* hour, uint8_t* minute, uint8_t* second);

// supply a pointer to the value you want to retrieve, or null to not retrieve that value
void rtc_getTime(uint8_t* year, uint8_t* month, uint8_t* day, uint8_t* dayOfWeek, uint8_t* hour, uint8_t* minute, uint8_t* second);

// quick time setting function
void rtc_setTimeBurst(uint8_t dayOfWeek, uint8_t hour, uint8_t minute, uint8_t second);

// supply a pointer to the value you want to set, or null to not set that value
void rtc_setTime(uint8_t* year, uint8_t* month, uint8_t* day, uint8_t* dayOfWeek, uint8_t* hour, uint8_t* minute, uint8_t* second);

void rtc_saveRam(uint8_t* data, int length);

uint8_t rtc_loadRam(uint8_t* data, int length);

// performs a test to see if information is saved properly, check logic analyzer waveforms to verify results;
void rtc_ramTest();

void rtc_run();

void rtc_init();

#endif