void sineTest()
{
    mp3_startSineTest();
    wdt_reset();
    _delay_ms(500);
    mp3_stopSineTest();
}

void lcdHelloWorld()
{
    lcd_setPos(0, 1);
    //                           1234567890123456
    fprintf_P(&lcd_stdout, PSTR("Hello           "));
    lcd_setPos(0, 2);
    fprintf_P(&lcd_stdout, PSTR("           World"));
    wdt_reset();
    _delay_ms(2000);
}

void eepromTest()
{
    // grab original copy
    loadFromEeprom(&eepromSettings, sizeof(eepromSettings));
    uint8_t before[sizeof(eepromSettings)];
    memcpy(before, &eepromSettings, sizeof(eepromSettings));
    
    // save and reload
    saveToEeprom(&eepromSettings, sizeof(eepromSettings));
    loadFromEeprom(&eepromSettings, sizeof(eepromSettings));
    
    if (memcmp(before, &eepromSettings, sizeof(eepromSettings)) != 0)
    {
        lcd_setPos(0, 1);
        //                           1234567890123456
        fprintf_P(&lcd_stdout, PSTR("EEPROM Test     "));
        lcd_setPos(0, 2);
        fprintf_P(&lcd_stdout, PSTR("          Failed"));
        wdt_reset();
        _delay_ms(2000);
    }
    else
    {
        lcd_setPos(0, 1);
        //                           1234567890123456
        fprintf_P(&lcd_stdout, PSTR("EEPROM Test     "));
        lcd_setPos(0, 2);
        fprintf_P(&lcd_stdout, PSTR("          Passed"));
        wdt_reset();
        _delay_ms(2000);

    }
}

#include "Lib/twi.h"

// copied from rtc.c, but now shows results on LCD
void ramTest()
{
    uint8_t buffer[0x3F - 0x08];
    uint8_t checksum1;
    for (int amount = 1; amount < 0x3F - 0x08 - 2; amount++)
    {
        wdt_reset();
        
        checksum1 = 0;
        for (int i = 0; i < amount; i++)
        {
            buffer[i] = i;
            checksum1 += i;
        }
        
        rtc_saveRam(buffer, amount);
        uint8_t newChecksum = rtc_loadRam(buffer, amount);
        
        uint8_t checksum2 = 0;
        for (int i = 0; i < amount; i++)
        {
            checksum2 += buffer[i];
        }
        
        if (checksum1 == checksum2 && checksum1 == newChecksum)
        {
            lcd_setPos(0, 1);
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("RAM Test Passed "));
            lcd_setPos(0, 2);
            fprintf_P(&lcd_stdout, PSTR("A: %d, Passed      "));
        }
        else
        {
            lcd_setPos(0, 1);
            //                           1234567890123456
            fprintf_P(&lcd_stdout, PSTR("RAM Test Failed "));
            lcd_setPos(0, 2);
            fprintf_P(&lcd_stdout, PSTR("%d %d %d %d           "), amount, checksum1, checksum2, newChecksum);
            
            _delay_ms(1000);
        }
    }
    _delay_ms(1000);
}