#include "timer.h"
#include <avr/io.h>
#include <avr/interrupt.h>

/*
// section no longer used because
// one shot timer is taken care of by timer0 instead, using a countdown
// that decrements once per second

static volatile uint64_t tmr2_overflowCnt;
static volatile uint64_t tmr2_overflowCompare;

ISR(TIMER2_OVF_vect)
{
    tmr2_overflowCnt++;
    if (tmr2_overflowCnt >= tmr2_overflowCompare)
    {
        // reached point, stop tmr2 completely
        tmr2_overflowCnt = 0;
        TCNT2 = 0;
        TCCR2B = 0;
        TIMSK2 &= ~_BV(TOIE2);
        
        oneShotTimer_event();
    }
}

// fire the event in x seconds
// assume clock speed is 8 MHz
void oneShotTimer_go(uint64_t seconds)
{
    if (seconds != 0)
    {
        tmr2_overflowCompare = seconds * 30;
        tmr2_overflowCnt = 0;

    }
    else
    {
        tmr2_overflowCompare = 1;
        tmr2_overflowCnt = 0;
    }

    TCNT2 = 0; // reset
    TCCR2B = 0b00000111; // start timer with lowest speed
    TIMSK2 |= _BV(TOIE2); // enable interrupt

    PORTD &= ~_BV(6);
}
//*/

static volatile uint64_t tmr0_overflowCnt;

ISR(TIMER0_OVF_vect)
{
    tmr0_overflowCnt++;
    if (tmr0_overflowCnt >= 31250)
    {
        tmr0_overflowCnt -= 31250;
        
        tmr0_oneSecondEvent();
    }
}

void tmr0_init()
{
    TCNT0 = 0; // reset
    TCCR0B = 0b00000001; // start timer with no prescaler
    TIMSK0 |= _BV(TOIE0); // enable overflow interrupt
}